<?
$config = array();

// Path to DiggerDiff files
$config['homepath'] = '.';

// Path to saved version of pages
$config['oldpath'] = $config['homepath'] . "/pages/old";

// Path to latest version of pages
$config['newpath'] = $config['homepath'] . "/pages/new";

// File to read titles and URLs from.
// Lines beginning with '#' and blank lines are ignored.
// Each line has two fields, Title and URL, separated by a TAB.
// Title is optional.  If no TAB is present, whole line is URL.
$config['urlfile'] = $config['homepath'] . "/urls.dat";

// Command to use for diff
$config['diffcmd'] = '/usr/bin/diff -bBsU 0';

// Command to use for lynx
$config['lynxcmd'] = '/usr/local/bin/lynx -source';

// Command to use for curl
$config['curlcmd'] = '/usr/local/bin/curl --silent';

// Command to use for HTTPS URLs
//$config['httpscmd'] = $config['lynxcmd'];
$config['httpscmd'] = $config['curlcmd'];

// Command to use for POST URLs
//   curl --form = multipart/form-data
//   curl --data = application/x-www-form-urlencoded
$config['postcmd'] = $config['curlcmd'] . " --data";

// Mode for source view diff display
// 1 = use <br>, 2 = use <pre>
$config['diffmode'] = 1;

// Show diff lines beginning with these chars
// For regular 'diff', '123456789<>-' should show all lines
// For 'diff --context' or 'diff -c', '*! +-' should show all lines
// For 'diff --context=0' or 'diff -C 0', '*!+-' should show all lines
// For 'diff --unified' or 'diff -u', '@ +-' should show all lines
// For 'diff --unified=0' or 'diff -U 0', '@+-' should show all lines
$config['diffshow'] = '@+-';

// Number of items to list on each page.
// Best to keep this relatively low when $config['updatemode']='demand',
// since it takes time to fetch each one.
$config['perpage'] = 10;

// If less than $config['agelimit'] seconds have passed since fetching a page,
// don't bother fetching it again.  Just use local copy.
$config['agelimit'] = 3600;

// Set how sites are checked for updates:  demand or cron
$config['updatemode'] = 'demand';

// Actions to take when run by cron.  Options are 'fetch', 'email' and 'save'.
// If web is primary interface, either just 'fetch' or 'fetch' and 'email' are
// sensible settings.  If email alerts are the primary interface, 'fetch' and
// 'email' and 'save' are probably all desired.
$config['cronactions'] = array('fetch', 'email');

// Email contents to send.  Sent in the order specified, except 'diffs'.
// If 'diffs' is specified, the diff of all CHANGED pages are included as
// separate attachments.  Options are 'fetch', 'new', 'same', 'error', 
// 'changed', 'save', 'diffs'.
$config['emailcontents'] = array('fetch', 'new', 'same', 'changed', 'error');

// Address to send email to
$config['emailto'] = '';

// Address to send email from
$config['emailfrom'] = '';

// Width of select list for editing
$config['editwidth'] = 80;

// Order of row display
// Choices are 'blank', 'edit', 'frames', 'list', 'pages', 'save'
$config['rows'] = array('pages', 'list', 'blank', 'pages', 'frames', 'save', 'edit');

// Order of column display in 'list' section
// Choices are 'archive', 'blank', 'current', 'edit', 'fetch', 'save', 'site', 'status'
$config['columns'] = array('edit', 'site', 'fetch', 'current', 'save', 'archive', 'status');

// Sort the URLs in the list?
$config['sorturls'] = TRUE;

// Default action to perform if none specified
// Useful choices are 'frame1', 'list'
$config['defaultaction'] = 'frame1';
?>
