<?php
// LICENSE
/*
DiggerDiff v1.0
Copyright (c) 2003, Dave Walton
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

1. Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.
*/
// END LICENSE


// SendMail() is adapted from the code posted by "alex at bartl dot net"
// at http://www.php.net/manual/en/ref.mail.php

/*
This might be some useful stuff to send out emails in either text
or html or multipart version, and attach one or more files or even
none to it.  I am not too sure how this script will behave under Windows.

function SendMail($From, $FromName, $To, $ToName, $Subject, $Text, $Html, $AttmFiles)
  $From      ... sender mail address like "my@address.com"
  $FromName  ... sender name like "My Name"
  $To        ... recipient mail address like "your@address.com"
  $ToName    ... recipients name like "Your Name"
  $Subject   ... subject of the mail like "This is my first testmail"
  $Text      ... text version of the mail
  $Html      ... html version of the mail
  $AttmFiles ... array containing the filenames to attach like array("file1","file2")
*/

function SendMail($From, $FromName, $To, $ToName, $Subject, $Text, $Html, $AttmFiles) {
  $OB = uniqid("----=_OuterBoundary_");
  $Html = empty($Html) ? nl2br($Text) : $Html;
  $Text = (empty($Text) && !empty($Html)) ? "Sorry, but you need an html mailer to read this mail." : $Text;
  $To = "$ToName <$To>";

  $headers = "MIME-Version: 1.0\r\n";
  $headers .= "From: $FromName <$From>\r\n";
//  $headers .= "To: $ToName <$To>\r\n";
  $headers .= "Reply-To: $FromName <$From>\r\n";
  $headers .= "X-Priority: 1\r\n";
  $headers .= "X-MSMail-Priority: High\r\n";
  $headers .= "X-Mailer: My PHP Mailer\r\n";
  $headers .= "Content-Type: multipart/mixed;\n\tboundary=\"$OB\"\r\n";

  //Messages start with text/html alternatives in OB
  $Msg = "This is a multi-part message in MIME format.\n";
  $Msg .= "\n--$OB\n";
  $IB = uniqid("----=_InnerBoundery_");
  $Msg .= "Content-Type: multipart/alternative;\n\tboundary=\"$IB\"\n\n";

  //plaintext section
  $Msg .= "\n--$IB\n";
  $Msg .= "Content-Type: text/plain;\n\tcharset=\"iso-8859-1\"\n";
  $Msg .= "Content-Transfer-Encoding: quoted-printable\n\n";
  // plaintext goes here
  $Msg .= qp_encode($Text) . "\n\n";

  // html section
  $Msg .= "\n--$IB\n";
  $Msg .= "Content-Type: text/html;\n\tcharset=\"iso-8859-1\"\n";
  $Msg .= "Content-Transfer-Encoding: base64\n\n";
  // html goes here
  $Msg .= chunk_split(base64_encode($Html)) . "\n\n";

  // end of IB
  $Msg .= "\n--$IB--\n";

  // attachments
  if (is_array($AttmFiles)) {
    foreach ($AttmFiles as $AttmFile) {
      $Msg .= "\n--$OB\n";
      $IB = uniqid("----=_InnerBoundery_");
      $Msg .= "Content-Type: multipart/alternative;\n\tboundary=\"$IB\"\n\n";
      $Msg .= "\n--$IB\n";
      $Msg .= "Content-Type: text/plain;\n\tcharset=\"iso-8859-1\"\n";
      $Msg .= "Content-Transfer-Encoding: base64\n\n";
      $Msg .= chunk_split(base64_encode(strip_tags($AttmFile))) . "\n\n";
      $Msg .= "\n--$IB\n";
      $Msg .= "Content-Type: text/html;\n\tcharset=\"iso-8859-1\"\n";
      $Msg .= "Content-Transfer-Encoding: base64\n\n";
      $Msg .= chunk_split(base64_encode($AttmFile)) . "\n\n";
      $Msg .= "\n--$IB--\n";
    }
  }

  //message ends
  $Msg .= "\n--$OB--\n";
  mail($To, $Subject, $Msg, $headers);   
  //syslog(LOG_INFO,"Mail: Message sent to $ToName <$To>");
}


function site_status($site, $config) {
  $oldfile = $config['oldpath'] . "/$site.html";
  $newfile = $config['newpath'] . "/$site.html";
  $oldcontents = '';
  $newcontents = '';

  if (file_exists($oldfile)) {
    $oldcontents = @file($oldfile);
    $oldcontents = implode('', $oldcontents);
  }
  $oldmd5 = md5($oldcontents);
  if (file_exists($newfile)) {
    $newcontents = @file($newfile);
    $newcontents = implode('', $newcontents);
  }
  $newmd5 = md5($newcontents);

  if (empty($newcontents)) {
    return('ERROR');
  } else if (empty($oldcontents)) {
    return('NEW');
  } else if ($newmd5 !== $oldmd5) {
    return('CHANGED');
  } else {
    return('SAME');
  }
}


// This function derived from code at
// www.oscdox.com/crossx/includes/classes/mime.php.source.html
function qp_encode($input , $line_max = 76) {
  $lines = preg_split("/\r\n|\r|\n/", $input);
  //$eol = $this->lf;
  $eol = "\n";
  $escape = '=';
  $output = '';

  while (list(, $line) = each($lines)) {
    $linlen = strlen($line);
    $newline = '';

    for ($i = 0; $i < $linlen; $i++) {
      $char = substr($line, $i, 1);
      $dec = ord($char);

  // convert space at eol only
      if ( ($dec == 32) && ($i == ($linlen - 1)) ) {
        $char = '=20';
      } elseif ($dec == 9) {
  // Do nothing if a tab.
      } elseif ( ($dec == 61) || ($dec < 32 ) || ($dec > 126) ) {
        $char = $escape . strtoupper(sprintf('%02s', dechex($dec)));
      }

  // $this->lf is not counted
      if ((strlen($newline) + strlen($char)) >= $line_max) {
  // soft line break; " =\r\n" is okay
        $output .= $newline . $escape . $eol;
        $newline = '';
      }
      $newline .= $char;
    }
    $output .= $newline . $eol;
  }
  // Don't want last crlf
  $output = substr($output, 0, -1 * strlen($eol));

  return $output;
}


function action_cron($config) {
  // need array_unique and array_search!
  if ($config['updatemode'] === 'cron') {
    $sitedata = load_urls($config['urlfile'], $config['sorturls']);

    foreach ($config['cronactions'] as $action) {
      if ($action === 'fetch') {
        $fetchtext = fetch_pages(1, count($sitedata)-1, $config, $sitedata);
        break;
      }
    }

    foreach ($config['cronactions'] as $action) {
      if ($action === 'email') {
        $dodiff = FALSE;
	$diffs = array();
        foreach ($config['emailcontents'] as $part) {
	  if ($part === 'diffs') {
            include_once('./dd_diff.php');
	    $dodiff = TRUE;
	    break;
	  }
	}
        $newtext = "NEW PAGES:\n";
	$sametext = "UNCHANGED PAGES:\n";
	$changedtext = "CHANGED PAGES:\n";
	$errortext = "PAGES WITH ERRORS:\n";

        foreach ($sitedata as $data) {
          $status = site_status($data['md5'], $config);
	  switch ($status) {
	    case 'NEW':
	      $newtext .= $data['title'] . "\n";
	      break;
	    case 'SAME':
	      $sametext .= $data['title'] . "\n";
	      break;
	    case 'CHANGED':
	      $changedtext .= $data['title'] . "\n";
	      if ($dodiff === TRUE) {
                $diffs[] = action_diff($data['md5'], 'render', $config);
	      }
	      break;
	    case 'ERROR':
	      $errortext .= $data['title'] . "\n";
	      break;
	  }
        }

        break;
      }
    }

    foreach ($config['cronactions'] as $action) {
      if ($action === 'save') {
        include_once('./dd_save.php');
        $savetext = action_save(0, $config);
        break;
      }
    }

    foreach ($config['cronactions'] as $action) {
      if ($action === 'email') {
	$emailbody = '';
	$emailattach = array();
        foreach ($config['emailcontents'] as $part) {
	  switch ($part) {
	    case 'fetch':
	      $emailbody .= "$fetchtext\n";
	      break;
	    case 'new':
	      $emailbody .= "$newtext\n";
	      break;
	    case 'same':
	      $emailbody .= "$sametext\n";
	      break;
	    case 'changed':
	      $emailbody .= "$changedtext\n";
	      break;
	    case 'error':
	      $emailbody .= "$errortext\n";
	      break;
	    case 'save':
	      $emailbody .= "$savetext\n";
	      break;
	    case 'diffs':
	      $emailattach = $diffs;
	      break;
	  }
	}
	$emailbody = (empty($emailbody)) ? 'No email body configured.' : $emailbody;
        SendMail($config['emailfrom'], 'DiggerDiff', $config['emailto'], 'DiggerDiff admin', 'DiggerDiff page changes.', $emailbody, '', $emailattach);
	break;
      }
    }
  }
}

?>
