<?php
// LICENSE
/*
DiggerDiff v1.0
Copyright (c) 2003, Dave Walton
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

1. Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.
*/
// END LICENSE


function action_save($page, $config, $site='') {
  global $PHP_SELF;

  $return = '';
  $sitedata = load_urls($config['urlfile'], $config['sorturls']);

  if (empty($site)) {
    $return .= print_header('strict', '- Save State');
  } else {
    // The ONLY reason this is Transitional instead of Strict is that
    // Strict doesn't allow the 'target' attribute of the 'a' tag.
    // (Of course, use of '&' instead of '&amp;' in links in the URL
    // list are an issue for both standards.)
    $return .= print_header('trans', "- View List - Page $page");
  }
  $return .= "<body>\n";

  $goodfiles = array();

  $output = '';
  foreach ($sitedata as $data) {
    $urlmd5 = $data['md5'];
    $goodfiles[] = "$urlmd5.html";
    if (!empty($site) && ($urlmd5 !== $site)) {
      continue;
    }
    $oldfile = $config['oldpath'] . "/$urlmd5.html";
    $newfile = $config['newpath'] . "/$urlmd5.html";
    $oldcontents = @file($oldfile);
    if ($oldcontents !== FALSE) {
      $oldcontents = implode('', $oldcontents);
    }
    $newcontents = @file($newfile);
    if (($newcontents !== FALSE) && !empty($newcontents)) {
      $newcontents = implode('', $newcontents);
      $oldmd5 = md5($oldcontents);
      $newmd5 = md5($newcontents);
      if ($oldcontents === FALSE) {
        $newoutput = 'NEW: [' . $data['title'] . ']';
      } else if ($oldmd5 !== $newmd5) {
        $newoutput = 'CHANGED: [' . $data['title'] . ']';
      } else {
        $newoutput = '';
      }
      if (!empty($newoutput)) {
        $output .= (empty($site)) ? "$newoutput<br />\n" : "$newoutput\n";
        copy($newfile, $oldfile);
      }
    }
  }

  if (empty($site)) {
    $return .= "<dl>\n";
    $return .= "<dt>Saving NEW and CHANGED pages to archive...</dt>\n";
    $return .= "<dd>$output</dd>\n";
    $return .= "</dl>\n";
  } else {
    if (!empty($output)) {
      $return .= "<p>\n";
      $return .= "Saving $output";
      $return .= "</p>\n";
    }
  }

  $output = '';
  $dirlist = array($config['oldpath'], $config['newpath']);
  foreach ($dirlist as $dirname) {
    $dir = opendir($dirname);
    while ($filename = readdir($dir)) {
      if ($filename === FALSE) {
        break;
      }
      if (preg_match('/^([^\W_]+)\.html$/', $filename, $matches) > 0) {
        if (!in_array($filename, $goodfiles)) {
	  $output .= "$dirname/$filename<br />\n";
          unlink("$dirname/$filename");
        }
      }
    }
    closedir($dir);
  }

  if (!empty($output)) {
    $return .= "<dl>\n";
    $return .= "  <dt>Deleting obsolete files...</dt>\n";
    $return .= "  <dd>$output</dd>\n";
    $return .= "</dl>\n";
  }

  if (empty($site)) {
    $return .= "<p>\n";
    $return .= "<a href=\"$PHP_SELF?action=list&amp;page=$page\">Return to site list.</a>\n";
    $return .= "</p>\n";
    $return .= "</body>\n";
    $return .= "</html>\n";
  } else if ($page > 0) {
    include_once('./dd_list.php');
    $return .= action_list($page, $config);
  }

  return($return);
}

?>
